package com.winhc.bigdata.flink.java.constant;

import com.winhc.bigdata.flink.java.utils.EnvironmentProperties;
import org.apache.flink.api.java.utils.ParameterTool;

import java.util.HashMap;
import java.util.Map;

/**
 * @author: XuJiakai
 * 2021/8/31 16:17
 */
public class EnvConst {
    private static final EnvironmentProperties env = new EnvironmentProperties();
    public static ParameterTool createParameterTool(final String[] args) throws Exception {
        return ParameterTool
                .fromMap(env.getSource())
                .mergeWith(ParameterTool.fromArgs(args))
                .mergeWith(ParameterTool.fromSystemProperties())
                .mergeWith(ParameterTool.fromMap(getenv()));// mergeWith 会使用最新的配置
    }

    //获取 Job 设置的环境变量
    private static Map<String, String> getenv() {
        Map<String, String> map = new HashMap<>();
        for (Map.Entry<String, String> entry : System.getenv().entrySet()) {
            map.put(entry.getKey().toLowerCase().replace('_', '.'), entry.getValue());
        }
        return map;
    }



    public static Map<String, String> getMapByPrefix(String prefix) {
        return env.getMapByPrefix(prefix);
    }

    public static String getValue(String key) {
        return getValue(key, null);
    }

    public static String getValue(String key, String orDefault) {
        String value = env.getValue(key);
        return value == null ? orDefault : value;
    }
}
