package com.winhc.bigdata.flink.java.entity;

import com.alibaba.fastjson.JSON;

import java.util.Objects;

/**
 * @author ZhangJi
 * @since 2021-10-18 17:37
 */
public class ValidationExceptionEntity<T> {
    private String name;
    private String message;
    private T data;

    public ValidationExceptionEntity() {
    }

    public ValidationExceptionEntity(String name, String message, T data) {
        this.name = name;
        this.message = message;
        this.data = data;
    }

    public String getName() {
        return name;
    }

    public void setName(String name) {
        this.name = name;
    }

    public String getMessage() {
        return message;
    }

    public void setMessage(String message) {
        this.message = message;
    }

    public T getData() {
        return data;
    }

    public void setData(T data) {
        this.data = data;
    }

    @Override
    public boolean equals(Object o) {
        if (this == o) return true;
        if (o == null || getClass() != o.getClass()) return false;

        ValidationExceptionEntity<?> that = (ValidationExceptionEntity<?>) o;

        if (!Objects.equals(name, that.name)) return false;
        if (!Objects.equals(message, that.message)) return false;
        return Objects.equals(data, that.data);
    }

    @Override
    public int hashCode() {
        int result = name != null ? name.hashCode() : 0;
        result = 31 * result + (message != null ? message.hashCode() : 0);
        result = 31 * result + (data != null ? data.hashCode() : 0);
        return result;
    }

    @Override
    public String toString() {
        return "ValidationExceptionEntity{" +
                "name='" + name + '\'' +
                ", message='" + message + '\'' +
                ", data=" + data +
                '}';
    }

    public static <T> ValidationExceptionEntity<T> of(Exception e, T data) {
        return new ValidationExceptionEntity<>(e.getClass().getName(), e.getMessage(), data);
    }


}
