package com.winhc.bigdata.flink.java.jobs;

import com.alibaba.fastjson.JSON;
import com.alibaba.fastjson.JSONObject;
import com.winhc.bigdata.flink.java.utils.KafkaSourceUtils;
import org.apache.flink.api.common.functions.FilterFunction;
import org.apache.flink.streaming.api.datastream.DataStreamSource;
import org.apache.flink.streaming.api.datastream.SingleOutputStreamOperator;
import org.apache.flink.streaming.api.environment.StreamExecutionEnvironment;
import org.apache.flink.streaming.connectors.kafka.FlinkKafkaConsumer;

/**
 * @author π
 * @Description:
 * @date 2021/10/18 16:39
 */
public class TestJob2 {
    public static void main(String[] args) throws Exception {
        StreamExecutionEnvironment env = StreamExecutionEnvironment.getExecutionEnvironment();
        //env.setParallelism(1);
        FlinkKafkaConsumer<String> kafkaSource = KafkaSourceUtils.getKafkaSource("flink_test", "xjk_test");
        DataStreamSource<String> kafkaDS = env.addSource(kafkaSource);
        SingleOutputStreamOperator<JSONObject> jsonObjDS = kafkaDS.map(json->{
            System.out.println("json: "+json);
            return JSON.parseObject(json);
        }).name("map name");
        SingleOutputStreamOperator<JSONObject> filterDS = jsonObjDS.filter((FilterFunction<JSONObject>) value -> !value.isEmpty()).name("filter name");
        filterDS.print();
        //filterDS.addSink(new HoloSink()).name("Holo Sink");
        env.execute("BaseJob");
    }
}
