package com.winhc.bigdata.flink.java.source;

import com.winhc.bigdata.flink.java.constant.EnvConst;
import org.apache.flink.api.common.serialization.SimpleStringSchema;
import org.apache.flink.connector.kafka.source.KafkaSource;
import org.apache.flink.connector.kafka.source.enumerator.initializer.OffsetsInitializer;
import org.apache.flink.kafka.shaded.org.apache.kafka.clients.consumer.OffsetResetStrategy;

/**
 * @author: XuJiakai
 * 2021/9/1 16:36
 */
public class KafkaSourceBuilder4J {
    public static KafkaSource<String> buildSourceFunction(String topic) {
        String profile = EnvConst.getValue("profile.activate");
        OffsetsInitializer offsets;
        if (profile.equals("dev")) {
            offsets = OffsetsInitializer.earliest();
        } else {
            offsets = OffsetsInitializer.committedOffsets(OffsetResetStrategy.EARLIEST);
        }
        return buildSourceFunction(topic, offsets);
    }

    //TODO unfixed: Deserialization schema is required but not provided.
    public static KafkaSource<String> buildSourceFunction(String topic, OffsetsInitializer offsetsInitializer) {
        String bootstrapServers = EnvConst.getValue("winhc.kafka.bootstrap-servers");
        String groupId = EnvConst.getValue("winhc.kafka.group-id");
        KafkaSource<String> build = KafkaSource.<String>builder()
                .setBootstrapServers(bootstrapServers)
                .setValueOnlyDeserializer(new SimpleStringSchema())
                .setGroupId(groupId)
                .setTopics(topic)
                .setStartingOffsets(offsetsInitializer)
                .build();
        return build;
    }
}
