package com.winhc.bigdata.flink.java.utils;

import cn.hutool.core.util.ClassUtil;
import com.alibaba.fastjson.JSONObject;
import com.winhc.bigdata.flink.java.BaseEntity;

import java.util.*;
import java.util.stream.Collectors;

/**
 * @author: XuJiakai
 * 2021/8/31 18:03
 */
public class Json2EntityUtils {
    private static final Map<String, ? extends Class<?>> collect;

    static {
        Set<Class<?>> c = ClassUtil.scanPackageBySuper("com.winhc.bigdata.filnk.java", BaseEntity.class);
        collect = c.stream().collect(Collectors.toMap(e -> FieldNameUtils.hump2Underline(e.getSimpleName()), e -> e));
    }

    public static BaseEntity parseEntity(String tn, String json) {
        BaseEntity o = ((BaseEntity) JSONObject.parseObject(json, collect.get(tn)));
        return o;
    }

    public static List<BaseEntity> parseArrayEntity(String tn, String json) {
        List<?> objects = JSONObject.parseArray(json, collect.get(tn));
        return ((List<BaseEntity>) objects);
    }

    public static Class<BaseEntity> getClazz(String tn) {
        return ((Class<BaseEntity>) collect.get(tn));
    }

    public static List<String> getTn() {
        return new ArrayList<>(collect.keySet());
    }

    public static void main(String[] args) {
        String json = "{\n" +
                "    \"ACTUAL_CAPITAL_AMOUNT\": \"\",\n" +
                "    \"LNG\": \"118.74012977757219\",\n" +
                "    \"NEW_CID\": \"3031495173\",\n" +
                "    \"CREDIT_CODE\": \"91320100MA1N042DXN\",\n" +
                "    \"LOGO\": \"/logo/lll/135d6a29aa603f758a4297c71021731b.png@!f_200x200\",\n" +
                "    \"HISTORY_NAMES\": \"\",\n" +
                "    \"PROVINCE_CODE\": \"\",\n" +
                "    \"WECHAT_PUBLIC_NUM\": \"\",\n" +
                "    \"ACTUAL_CAPITAL_CURRENCY\": \"人民币\",\n" +
                "    \"rowkey\": \"00e30d8f19b9a54d1fbdf561a339918a\",\n" +
                "    \"CREATE_TIME\": \"2021-02-13 03:05:53\",\n" +
                "    \"NAME_ALIAS\": \"懿馨四\",\n" +
                "    \"REG_STATUS\": \"注销\",\n" +
                "    \"CITY_CODE\": \"\",\n" +
                "    \"REG_CAPITAL_AMOUNT\": \"152400\",\n" +
                "    \"REG_INSTITUTE\": \"南京市市场监督管理局\",\n" +
                "    \"REG_STATUS_STD\": \"存续\",\n" +
                "    \"CATE_FIRST_CODE\": \"28\",\n" +
                "    \"ESTIBLISH_TIME\": \"2016-11-17 00:00:00\",\n" +
                "    \"LEGAL_ENTITY_ID\": \"f3e1b78560e5c5f968559ad810c604b5\",\n" +
                "    \"TO_TIME\": \"\",\n" +
                "    \"CATE_SECOND_CODE\": \"63\",\n" +
                "    \"NAME\": \"南京懿馨四一八号文化艺术品投资合伙企业（有限合伙）\",\n" +
                "    \"BUSINESS_SCOPE\": \"文化艺术品投资；艺术品、工艺品销售。（依法须经批准的项目，经相关部门批准后方可开展经营活动）\",\n" +
                "    \"REG_CAPITAL\": \"0.1524万元人民币\",\n" +
                "    \"CANCEL_DATE\": \"2021-02-11 00:00:00\",\n" +
                "    \"NAME_EN\": \"\",\n" +
                "    \"REG_NUMBER\": \"320100001729363\",\n" +
                "    \"ORG_APPROVED_INSTITUTE\": \"\",\n" +
                "    \"ORG_NUMBER\": \"MA1N042DX\",\n" +
                "    \"REVOKE_REASON\": \"\",\n" +
                "    \"REG_CAPITAL_CURRENCY\": \"人民币\",\n" +
                "    \"COMPANY_TYPE\": \"1\",\n" +
                "    \"SCORE\": \"4736\",\n" +
                "    \"LEGAL_ENTITY_TYPE\": \"2\",\n" +
                "    \"CANCEL_REASON\": \"其他原因\",\n" +
                "    \"SOCIAL_SECURITY_STAFF_NUM\": \"0\",\n" +
                "    \"DELETED\": \"0\",\n" +
                "    \"EMAILS\": \"2221222014@qq.com\\t;\\tzxy@zixingyun.com\\t;\\tbenyue_ec@126.com\\t;\\t470936908@qq.com\\t;\\t\",\n" +
                "    \"BASE\": \"js\",\n" +
                "    \"PARENT_COMPANY_ID\": \"\",\n" +
                "    \"REVOKE_DATE\": \"\",\n" +
                "    \"APPROVED_TIME\": \"2021-02-11 00:00:00\",\n" +
                "    \"PHONES\": \"025-58807399\\t;\\t\",\n" +
                "    \"COUNTY_CODE\": \"\",\n" +
                "    \"COMPANY_ID\": \"00e30d8f19b9a54d1fbdf561a339918a\",\n" +
                "    \"REG_LOCATION\": \"南京市建邺区嘉陵江东街18号05栋7层\",\n" +
                "    \"FROM_TIME\": \"2016-11-17 00:00:00\",\n" +
                "    \"UPDATE_TIME\": \"2021-02-13 03:05:53\",\n" +
                "    \"COMPANY_ORG_TYPE\": \"有限合伙企业\",\n" +
                "    \"LEGAL_ENTITY_NAME\": \"南京犇越投资管理有限公司\",\n" +
                "    \"CATE_THIRD_CODE\": \"250\",\n" +
                "    \"LAT\": \"31.986383793889924\",\n" +
                "    \"CRAWLED_TIME\": \"2021-02-13 03:05:52\"\n" +
                "  }";

        BaseEntity company = parseEntity("company", json);
        System.out.println(company);

    }
}
