package com.winhc.bigdata.flink.config

import com.fasterxml.jackson.databind.JsonNode
import com.winhc.bigdata.flink.event.{ElasticSearchInfo, HbaseInfo, HologresInfo}
import com.winhc.bigdata.flink.utils.BaseUtils.cleanup
import com.winhc.bigdata.flink.utils.{BaseUtils, PreUDF}

/**
 * @author ZhangJi
 * @since 2021-10-18 11:42
 */
case class ArgsCompanyJob(
                           //                             tn: String,
                           hbaseInfo: HbaseInfo,
                           esInfo: ElasticSearchInfo,
                           holoInfo: HologresInfo,
                           md5_fields: Seq[String],
                           rowkey_udf: Function2[String, JsonNode, String] = null

                         )

object ArgsCompanyJob {
  val job_args = Map(
    "company_holder" -> ArgsCompanyJob(HbaseInfo("NG_RT_COMPANY_HOLDER", "F"),
      ElasticSearchInfo("winhc_rt_index_company_holder", "_doc"),
      HologresInfo("ng_rt_company_holder", "public"),
      null,
      (companyId, j) => {
        val row = PreUDF.company_holder_rowkey(j.get("holder_type").asInt(), j.get("holder_id").asText(), j.get("holder_name").asText())
        BaseUtils.concatws("_", companyId, BaseUtils.md5(cleanup(row)))
      }),
    "company_staff" -> ArgsCompanyJob(
      HbaseInfo("NG_RT_COMPANY_STAFF", "F"),
      ElasticSearchInfo("winhc_rt_index_company_staff", "_doc"),
      HologresInfo("ng_rt_company_staff", "public"),
      Seq("staff_name")
    )
  )
}
