package com.winhc.bigdata.flink.config


import com.alibaba.ververica.connector.shaded.hadoop3.org.apache.hadoop.conf.Configuration
import com.winhc.bigdata.flink.java.constant.EnvConst
import org.apache.flink.configuration.{ConfigOption, ConfigOptions}
import org.apache.hadoop.hbase.HBaseConfiguration
import java.util

import org.apache.flink.api.common.ExecutionConfig.GlobalJobParameters
import org.apache.flink.api.java.utils.ParameterTool

import scala.collection.JavaConverters._

/**
 * @author: XuJiakai
 * @date: 2021/8/31 17:11
 */
object HbaseConfig {
  def getHbaseConfiguration(): Configuration = {

    val map: util.Map[String, String] = EnvConst.getMapByPrefix("winhc.hbase.config")
    val configuration: Configuration = HBaseConfiguration.create
    for (elem <- map.asScala) {
      configuration.set(elem._1.replace("winhc.hbase.config.", ""), elem._2)
    }
    configuration
  }

  /**
   * open函数中获取参数
   * @param parameters Flink RichFunction Configuration
   * @param configs Flink ConfigOption
   * @return HBaseConfiguration
   */
  def getHbaseConfiguration(parameters: ParameterTool, configs: Seq[String]): Configuration = {
    val configuration: Configuration = HBaseConfiguration.create
    for (config <- configs) {

      val value = parameters.get(config)
      val key = config
      configuration.set(key.replace("winhc.hbase.config.", ""), value)
    }
    configuration
  }
}
