package com.winhc.bigdata.flink.event

import com.alibaba.fastjson.JSONObject
import com.fasterxml.jackson.databind.JsonNode
import com.winhc.bigdata.flink.utils.RowDataUtils
import org.json4s.JsonAST.JObject
import org.json4s.jackson.JsonMethods._
/**
 * @author ZhangJi
 * @since 2021-10-13 13:56
 */
object RowBaseDimEntity {


  def ofJsonNode(entry:(String,Seq[JsonNode]), companyMeta: (String, String)): RowBaseDimEntity = {
    val (dim, data) = entry
    ofJObject((dim,data.map(j=>fromJsonNode(j).asInstanceOf[JObject])),companyMeta)
  }
  def ofJObject(entry:(String,Seq[JObject]), companyMeta: (String, String)): RowBaseDimEntity = {
    val (dim, data) = entry
    val mapData = data.map(j => (RowDataUtils.generateRowKey(dim, asJsonNode(j)), j)).filter(t=>t._1!=null).toMap
    val (companyId, companyName) = companyMeta
    new RowBaseDimEntity(RowDataUtils.generateMetaInfo(dim, companyId, companyName), mapData, Map.empty)
  }


}

case class RowBaseDimEntity(metaInfo: MetaInfo, data: Map[String, JObject], var old: Map[String, JObject]) extends DimEntity {
  override def companyId: String = {
    Some(metaInfo).flatMap(m => m.company).map(c => c.companyId).orNull
  }

}
