package com.winhc.bigdata.flink.jobs.company_job_step

import com.alibaba.fastjson.JSON
import com.winhc.bigdata.flink.java.BaseEntity
import com.winhc.bigdata.flink.java.utils.Json2EntityUtils
import com.winhc.bigdata.flink.CompanyData

import org.apache.flink.api.scala._
import org.apache.flink.streaming.api.scala.DataStream

import scala.collection.JavaConverters._

/**
 * @author: XuJiakai
 * @date: 2021/9/1 14:10
 *
 *        接收kafka数据并转化
 */
case class step_01_kafka_transform(source: DataStream[String]) {
  def winhcTransform(): DataStream[CompanyData] = {
    source.map(str => {
      val jsonObject = JSON.parseObject(str)
      val companyId = jsonObject.getString("company_id")
      val companyName = jsonObject.getString("company_name")
      val content = jsonObject.getJSONObject("content")
      val map: Map[String, Seq[BaseEntity]] = content.keySet().asScala.map(tn => {
        (tn, content.getJSONArray(tn).toJavaList(Json2EntityUtils.getClazz(tn)).asScala)
      }).toMap
      CompanyData(companyId = companyId, companyName = companyName, content = map)
    })
  }
}
