package com.winhc.bigdata.flink.jobs.company_job_step

import com.winhc.bigdata.flink.java.BaseEntity
import com.winhc.bigdata.flink.java.utils.Json2EntityUtils
import com.winhc.bigdata.flink.CompanyData
import com.winhc.bigdata.flink.sink.OdpsSinkBuilder
import com.winhc.bigdata.flink.utils.DateUtils
import org.apache.flink.api.java.tuple.Tuple2
import org.apache.flink.api.scala._
import org.apache.flink.streaming.api.functions.ProcessFunction
import org.apache.flink.streaming.api.functions.sink.SinkFunction
import org.apache.flink.streaming.api.scala.{DataStream, OutputTag}
import org.apache.flink.types.Row
import org.apache.flink.util.Collector

import scala.collection.JavaConverters._

/**
 * @author: XuJiakai
 * @date: 2021/9/1 14:31
 *        将原始数据写出到ods，用于备份(暂不写出)
 */
case class step_02_sink_2_ods(dataStream: DataStream[CompanyData]) {

  def saveToOdpsOds(): DataStream[CompanyData] = {
    val map = Json2EntityUtils.getTn.asScala.map(t => {
      (t, new OutputTag[(String, Seq[BaseEntity])](t) {})
    }).toMap

    val processStream = dataStream.flatMap(e => e.content)
      .process(new ProcessFunction[(String, Seq[BaseEntity]), (String, Seq[BaseEntity])]() {
        override def processElement(value: (String, Seq[BaseEntity]), ctx: ProcessFunction[(String, Seq[BaseEntity]), (String, Seq[BaseEntity])]#Context, out: Collector[(String, Seq[BaseEntity])]): Unit = ctx.output(map(value._1), value)
      })

    for (elem <- map) {
      val tn = elem._1
      val sink: SinkFunction[Tuple2[Boolean, Row]] = OdpsSinkBuilder.buildSinkFunction(s"inc_ods_$tn", s"ds=${DateUtils.getYesterday()}")
      processStream.getSideOutput(elem._2)
        .flatMap(r => r._2)
        .map(r => new Tuple2(true, r.toRow))
        .addSink(sink)
    }

    dataStream
  }
}
