package com.winhc.bigdata.flink.source

import com.alibaba.ververica.connectors.odps.{ODPSStreamSource, OdpsOptions}
import com.winhc.bigdata.flink.java.constant.EnvConst
import com.winhc.bigdata.flink.java.source.OdpsSourceBuilder4J
import org.apache.flink.configuration.Configuration

/**
 * @author: XuJiakai
 * @date: 2021/8/31 11:48
 */
object OdpsSourceBuilder {
  def buildSourceFunction(tableName: String, partition: String = null): ODPSStreamSource = {
    var project = EnvConst.getValue("odps.default-project")
    var tn = tableName
    if (tableName.contains(".")) {
      val strings = tableName.split("\\.")
      project = strings(0)
      tn = strings(1)
    }
    val conf = new Configuration()
    conf.setString(OdpsOptions.END_POINT.key(), EnvConst.getValue("odps.url.end-point"))
    conf.setString(OdpsOptions.TUNNEL_END_POINT.key(), EnvConst.getValue("odps.url.tunnel-end-point"))
    conf.setString(OdpsOptions.PROJECT_NAME.key(), project)
    conf.setString(OdpsOptions.TABLE_NAME.key, tn)
    conf.setString(OdpsOptions.ACCESS_ID.key(), EnvConst.getValue("odps.prod-account.access-id"))
    conf.setString(OdpsOptions.ACCESS_KEY.key(), EnvConst.getValue("odps.prod-account.access-key"))
    if (partition != null)
      conf.setString(OdpsOptions.PARTITION.key, partition)
    val odpsSource = new OdpsSourceBuilder4J(conf).buildSourceFunction
    odpsSource
  }

}
