package com.winhc.bigdata.flink.utils

import com.fasterxml.jackson.databind.{DeserializationFeature, ObjectMapper}
import org.apache.commons.lang3.StringUtils
import org.apache.flink.table.utils.EncodingUtils

/**
 * @author XuJiakai
 * @since 2021/9/1 15:25
 */
object BaseUtils {
  //去其他符号 去空格
  val objectmapper: ObjectMapper = new ObjectMapper().configure(DeserializationFeature.FAIL_ON_UNKNOWN_PROPERTIES, false)
  private val pattern = "[^\\u4e00-\\u9fa50-9a-zA-Z]".r

  //去其他符号 去空格  补全null
  def cleanup(s: String): String = if (StringUtils.isBlank(s)) "" else pattern replaceAllIn(s, "")


  def hbaseTableName(dim: String): String = s"NG_${dim.toUpperCase}"

  def md5(s: String): String = EncodingUtils.hex(EncodingUtils.md5(s))

  def concatws(seq: String, strings: String*): String = strings.mkString(seq)

  def isWindows: Boolean = System.getProperty("os.name").contains("Windows")


}
