package com.winhc.bigdata.flink.utils

import org.apache.commons.lang3.time.DateFormatUtils

import java.text.SimpleDateFormat
import java.util.{Calendar, Date, Locale}

/**
 * @author: XuJiakai
 * @date: 2021/9/1 15:24
 */
object DateUtils {

  def nowDate(pattern: String = "yyyy-MM-dd"): String = {
    new SimpleDateFormat(pattern).format(new Date)
  }

  def getYesterday(): String = {
    atDaysAfter(-1, nowDate("yyyyMMdd"))
  }

  def atDaysAfter(n: Int, time: String, pattern: String = "yyyyMMdd"): String = {
    import java.text.SimpleDateFormat
    val newtime: Date = new SimpleDateFormat("yyyyMMdd").parse(time)
    val c = Calendar.getInstance(Locale.CHINA)
    c.setTimeInMillis(newtime.getTime)
    c.add(Calendar.DATE, 1 * n)
    DateFormatUtils.format(c.getTime.getTime, pattern)
  }


}
