package com.winhc.bigdata.flink.utils

import com.alibaba.fastjson.JSON
import org.apache.commons.lang3.StringUtils

import scala.collection.mutable

/**
 * @author ZhangJi
 * @since 2021-10-15 11:28
 */
object PreUDF {
  def replace_rowkey(use_user_defined_rowkey: String, new_rowkey: String): String = {
    if (StringUtils.isEmpty(use_user_defined_rowkey)) {
      new_rowkey
    } else {
      use_user_defined_rowkey
    }
  }

  def company_holder_rowkey(holder_type: Long, holder_id: String, holder_name: String): String = {
    if (2 == holder_type) {
      holder_id
    } else {
      holder_name
    }
  }

  def get_fixed_val(key_no: String, name: String): String = {
    if (StringUtils.isEmpty(key_no)) {
      name
    } else {
      if (key_no.length == 32) {
        key_no
      } else {
        name
      }
    }
  }

  def equity_info_rowkey(pledgee_info: String, pledgor_info: String): String = {
    try {
      def get_seq(key: String, value: String): String = {
        val jSONArray = JSON.parseArray(value)
        if (jSONArray.isEmpty) {
          return ""
        }
        val arr = mutable.ArrayBuffer[String]()
        for (i <- 0 until jSONArray.size()) {
          val jSONObject = jSONArray.getJSONObject(i)
          arr.append(jSONObject.getString(key))
        }
        arr.distinct.sorted.mkString("、")
      }

      val str = get_seq("pledgee", pledgee_info) + " " + get_seq("pledgor", pledgor_info)
      str
    } catch {
      case ex: Exception => {
        ""
      }
    }
  }


}
